package actores.behaviours;

import jade.core.Agent;
import jade.core.behaviours.WakerBehaviour;
import jade.core.behaviours.TickerBehaviour;

import jade.core.AID;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class Dj extends Agent
 {
	int i = 0 ;
	private AID[] listaChicas; // Lista de las chicas del bar 
	private String[] artistas = 
	{"Avicii ft David Guetta","Hardwell","Armin van Buuren feat Jennifer Rene","Tom Hangs","Avicii","Manolo Escobar",
	"Sunshine vs Florence and the machine - Spectrum","Never Say Goodbye","Fine without you","Dancing in My Head","Wake me up","Mi carro me lo robaron"};

	protected void setup() 
	{
	System.out.println("");
    System.out.println("[Actores DJ] Unos misteriosos agentes acaban de entrar en al discoteca ibizenca.");
	
	

    // TickerBehaviour 
    addBehaviour
	(
		new TickerBehaviour(this, 40000) 
		{
			protected void onTick() 
			{
				System.out.println("\n---------= Entra en escena un nuevo dj =---------\n" + artistas[i] + " esta pinchando " + artistas[i+6] +"\n" );
				
				i++;
			} 
		}
	);


    addBehaviour
	(new WakerBehaviour(this, 210000) 
	{
      protected void onWake()
	  {
        System.out.println("["+myAgent.getLocalName()+"] La discoteca se cierra por hoy, todos fuera o soltamos los perros!!");
		
		DFAgentDescription template = new DFAgentDescription();
		ServiceDescription sd = new ServiceDescription();
		sd.setType("tipo-buscona");
	    template.addServices(sd);
			  
		try 
		{
			DFAgentDescription[] result = DFService.search(myAgent, template); 
			System.out.println("[" + getLocalName() + "] He encontrado las siguientes chicas:");
			listaChicas = new AID[result.length];
			for (int i = 0; i < result.length; ++i)
			{
					listaChicas[i] = result[i].getName();
					System.out.println("[" + getLocalName() + "] >>> [" + listaChicas[i].getLocalName() + "] Fuera de mi local.");
					ACLMessage cfp = new ACLMessage(ACLMessage.CFP);
					cfp.addReceiver(listaChicas[i]);
			 
			
					cfp.setConversationId("adios");
					cfp.setReplyWith("cfp"+System.currentTimeMillis()); 
					myAgent.send(cfp);
					
					doWait(5000);
			}
		}
		catch (FIPAException fe)
		{
				fe.printStackTrace();
		} 
		
		doWait(10000);
        myAgent.doDelete();
      } 
    });
  } 
   
	 protected void takeDown()
	{
		System.out.println("\n[" + getLocalName() + "] abandona la discoteca cansado.\n========== FIN EJECUCION ==========");
	}   
  
}